﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.32
@EndOfDesignText@
#IgnoreWarnings:12
Sub Class_Globals
	Private stepsm As Map
	Private BANano As BANano 'ignore
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	stepsm.Initialize 
End Sub

'add a step for an element with a description
Sub AddStep(eID As String,eDescription As String) As UOEEasyHint
	Dim eachstep As Map
	eachstep.Initialize
	eID = eID.tolowercase
	Dim sKey As String = $"next #${eID}"$
	eachstep.Put(sKey,eDescription)
	stepsm.Put(eID,eachstep)
	Return Me
End Sub

'add a click step for an element with a description. For example a button, the expection will be that it will be clicked.
Sub AddClick(eID As String,eDescription As String) As UOEEasyHint
	Dim eachstep As Map
	eachstep.Initialize
	eID = eID.tolowercase
	Dim sKey As String = $"click #${eID}"$
	eachstep.Put(sKey,eDescription)
	stepsm.Put(eID,eachstep)
	Return Me
End Sub

'add a key press event for an element, the expectation will be the user to type content and press enter
Sub AddKeyPress(eID As String,eDescription As String) As UOEEasyHint
	Dim eachstep As Map
	eachstep.Initialize
	eID = eID.tolowercase
	Dim sKey As String = $"key #${eID}"$
	eachstep.Put(sKey,eDescription)
	eachstep.Put("keyCode", "13")
	stepsm.Put(eID,eachstep)
	Return Me
End Sub

'indicate the ending element for the hints
Sub EndsOn(eID As String)
	eID = eID.tolowercase
	HideSkip(eID)
	SetNextButton(eID,"Got it!")
End Sub

'hide the skip button for an element
Sub HideSkip(eID As String) As UOEEasyHint
	eID = eID.tolowercase
	Dim rec As Map
	If stepsm.ContainsKey(eID) Then
		rec = stepsm.Get(eID)
		rec.Put("showSkip", False)
		stepsm.Put(eID,rec)
	End If
	Return Me
End Sub

'change the text for the next button of this element
Sub SetNextButton(eID As String, Text As String) As UOEEasyHint
	eID = eID.tolowercase
	Dim rec As Map
	If stepsm.ContainsKey(eID) Then
		rec = stepsm.Get(eID)
		Dim sb As Map = CreateMap("className":"myNext","text":Text)
		rec.Put("nextButton",sb)
		stepsm.Put(eID,rec)
	End If
	Return Me
End Sub

'change the skip button text for the element
Sub SetSkipButton(eID As String, Text As String) As UOEEasyHint
	eID = eID.tolowercase
	Dim rec As Map
	If stepsm.ContainsKey(eID) Then
		rec = stepsm.Get(eID)
		Dim sb As Map = CreateMap("className":"mySkip","text":Text)
		rec.Put("skipButton",sb)
		stepsm.Put(eID,rec)
	End If
	Return Me
End Sub

'set a hint to be a circle for an element
Sub SetCircle(eID As String, radius As Int) As UOEEasyHint
	eID = eID.tolowercase
	Dim rec As Map
	If stepsm.ContainsKey(eID) Then
		rec = stepsm.Get(eID)
		rec.Put("shape","circle")
		If radius > 0 Then rec.Put("radius", radius)
		stepsm.Put(eID,rec)
	End If
	Return Me
End Sub

'run the easyhint plugin
Sub Run
	'build the steps
	Dim enjoyhint_script_steps As List
	enjoyhint_script_steps.Initialize 
	For Each stepm As Map In stepsm.Values
		enjoyhint_script_steps.Add(stepm)
	Next
	'create the object
	Dim easySteps_instance As BANanoObject 
	easySteps_instance.Initialize2("EnjoyHint",Null)
	easySteps_instance.RunMethod("set",Array(enjoyhint_script_steps))
	easySteps_instance.RunMethod("run",Null)
End Sub